#!/bin/sh
#
# Frenzy config backup script
# v0.1 by Sergei Mozhaisky (techniX)
#
mkarch()
{
DDIR=$1
DBAS=$2
DB="/frenzy/db/${DBAS}"
DFILE1="/tmp/backupdb1"
DFILE2="/tmp/backupdb2"
cd /
echo > ${DFILE1}
for f in `find ${DDIR} -type f -print | sort`
do
  MD=`md5 ${f}`
  echo ${MD} >> ${DFILE1}
done

diff -u ${DB} ${DFILE1} | grep "+MD5" | grep -v "cache4" | awk -F" " '{print $2;}' > ${DFILE2}
sed "s/(//" < ${DFILE2} > ${DFILE1}
sed "s/)//" < ${DFILE1} > ${DFILE2}
mkdir /tmp/arch > /dev/null 2>&1
tar cyvf /tmp/arch/${DBAS}.tbz -I ${DFILE2}
rm ${DFILE1}
rm ${DFILE2}

}
# mkarch

MP="/mnt/floppy"
printf " /dev/fd0  ${MP}..."

mount_msdos /dev/fd0 ${MP} > /dev/null 2>&1

if [ $? = 0 ]; then
    printf " OK.\n"
else
    echo " !"
    exit 1
fi;

echo " ..."
echo "==> /etc"
mkarch etc etc
echo "==> /root"
mkarch root root
echo "==> /usr/local/etc"
mkarch usr/local/etc localetc
echo "==> /var/drweb"
mkarch var/drweb drweb

cd ${MP}
echo " ..."
mkdir frenzy.bk > /dev/null 2>&1
mv /tmp/arch/* frenzy.bk
touch frenzy.bk/backup.inf
date > frenzy.bk/backup.inf
exit;

